Summary:	letsencrypt/acme client implemented as a shell-script
Name:		dehydrated
Version:	0.7.1
Release:	1
License:	MIT
Group:		Applications/Networking
Source0:	https://github.com/lukas2511/dehydrated/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	0ebe5185b2c9bd721e95f95962dc377d
Source1:	httpd.conf
Source2:	lighttpd.conf
Source3:	nginx.conf
Source4:	domains.txt
Source5:	crontab
Source6:	config.sh
Source7:	01-ca-path.sh
Source8:	02-challenge-type.sh
Source9:	03-keys.sh
Source10:	04-renew.sh
Source11:	05-ocsp.sh
Source12:	06-hook.sh
Source13:	07-contact.sh
Source14:	08-curl.sh
Source30:	hook.sh
Source31:	hook.functions
Source32:	hook.custom_functions
Source33:	hook.global
Source34:	sudoers
Patch0:		tld.patch
URL:		https://github.com/lukas2511/dehydrated
BuildRequires:	rpmbuild(macros) >= 1.713
Requires:	ca-certificates
Requires:	crondaemon
Requires:	curl
Requires:	diffutils
Requires:	grep
Requires:	mktemp
Requires:	openssl-tools
Requires:	sed
Requires:	sudo
Requires:	webapps
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Suggests:	webserver(access)
Suggests:	webserver(alias)
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps

%description
This is a client for signing certificates with an ACME-server
(currently only provided by letsencrypt) implemented as a relatively
simple bash-script.

Current features:
- Signing of a list of domains
- Signing of a CSR
- Renewal if a certificate is about to expire or SAN (subdomains)
  changed
- Certificate revocation

%prep
%setup -q
%patch0 -p1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},{/etc/%{name},%{_webapps}/%{name}}/{conf.d,hooks,hooks.d},/etc/{cron,sudoers}.d} \
	$RPM_BUILD_ROOT/var/lib/%{name}/{accounts,acme-challenges,alpn-certs,certs}

install -p %{name} $RPM_BUILD_ROOT%{_sbindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_webapps}/%{name}/httpd.conf
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_webapps}/%{name}/lighttpd.conf
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_webapps}/%{name}/nginx.conf
cp -p %{SOURCE4} $RPM_BUILD_ROOT/etc/%{name}/domains.txt
cp -p %{SOURCE5} $RPM_BUILD_ROOT/etc/cron.d/%{name}
cp -p %{SOURCE6} $RPM_BUILD_ROOT/etc/%{name}/config
cp -p %{SOURCE7} %{SOURCE8} %{SOURCE9} %{SOURCE10} \
	%{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} \
	$RPM_BUILD_ROOT/etc/%{name}/conf.d/
install -p %{SOURCE30} $RPM_BUILD_ROOT/etc/%{name}/hooks/hook.sh
cp -p %{SOURCE31} $RPM_BUILD_ROOT/etc/%{name}/hooks/functions
cp -p %{SOURCE32} $RPM_BUILD_ROOT/etc/%{name}/hooks/custom_functions
cp -p %{SOURCE33} $RPM_BUILD_ROOT/etc/%{name}/hooks.d/global
cp -p %{SOURCE34} $RPM_BUILD_ROOT/etc/sudoers.d/%{name}

%pre
%groupadd -g 184 dehydrated

%postun
if [ "$1" = "0" ]; then
	%groupremove dehydrated
fi

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{name}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{name}

%triggerin -- lighttpd
%webapp_register lighttpd %{name}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{name}

%triggerin -- nginx
%webapp_register nginx %{name}

%triggerun -- nginx
%webapp_unregister nginx %{name}

%files
%defattr(644,root,root,755)
%doc README.md CHANGELOG LICENSE docs/*.md docs/examples/config
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/cron.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sudoers.d/%{name}
%dir %attr(750,root,http) %{_webapps}/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_webapps}/%{name}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_webapps}/%{name}/lighttpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_webapps}/%{name}/nginx.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/%{name}/config
%dir %attr(755,root,root) /etc/%{name}
%dir %attr(755,root,root) /etc/%{name}/conf.d
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/%{name}/conf.d/*.sh
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/%{name}/domains.txt
%dir %attr(755,root,root) /etc/%{name}/hooks
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/%{name}/hooks/custom_functions
%attr(640,root,root) /etc/%{name}/hooks/functions
%attr(750,root,root) /etc/%{name}/hooks/hook.sh
%dir %attr(755,root,root) /etc/%{name}/hooks.d
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/%{name}/hooks.d/global
%attr(755,root,root) %{_sbindir}/%{name}
%dir %attr(751,root,root) /var/lib/%{name}
%dir %attr(700,root,root) /var/lib/%{name}/accounts
%dir %attr(750,root,dehydrated) /var/lib/%{name}/alpn-certs
%dir %attr(750,root,dehydrated) /var/lib/%{name}/certs
# challenges are written here, need to be readable by webserver
%dir %attr(751,root,dehydrated) /var/lib/%{name}/acme-challenges
%changelog
* Mon May 15 2023 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/dehydrated.git;a=log;h=master

* Mon May 15 2023 Marcin Krol <hawk@tld-linux.org> 757e8ea
- updated to 0.7.1

* Fri Jan 01 2021 Marcin Krol <hawk@tld-linux.org> 680e540
- updated to 0.7.0

* Sun Aug 16 2020 Marcin Krol <hawk@tld-linux.org> b5d5d32
- updated to 0.6.5

* Wed Dec 19 2018 Marcin Krol <hawk@tld-linux.org> 75b6ad1
- run as root:dehydrated by default to allow special group read
  permission for certificates and keys

* Sat Jul 21 2018 Marcin Krol <hawk@tld-linux.org> bca4481
- updated CA paths

* Sun May 27 2018 Marcin Krol <hawk@tld-linux.org> 1af0682
- fix files

* Sun May 27 2018 Marcin Krol <hawk@tld-linux.org> 9bf026a
- updated to 0.6.2

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> a42ba50
- unify indentation

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> aa3e7a6
- add warning about file being overwritten by updates

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> 4569106
- make hooks.sh and system functions non-configs so they always get
  replaced during upgrade
- fixed some dir packaging

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> 7651f36
- added support for custom functions

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> 6e7bd3d
- doh, these are custom ones, do not duplicate function names

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> 79a156b
- added strartup and exit hooks
- marked hooks as system ones

* Sat Oct 28 2017 Marcin Krol <hawk@tld-linux.org> e44fc66
- use bash

* Fri Oct 27 2017 Marcin Krol <hawk@tld-linux.org> 99664be
- moved hook processing code to functions

* Wed Oct 25 2017 Marcin Krol <hawk@tld-linux.org> 62fe803
- works ok, release 1

* Wed Oct 25 2017 Marcin Krol <hawk@tld-linux.org> 1f6c17f
- apache_reload, not httpd_reload

* Wed Oct 25 2017 Marcin Krol <hawk@tld-linux.org> 607c371
- missed that one

* Wed Oct 25 2017 Marcin Krol <hawk@tld-linux.org> fdac690
- back to httpd for now, no time to move /etc/httpd to /etc/apache distro wide

* Wed Oct 25 2017 Marcin Krol <hawk@tld-linux.org> 6548e56
- s/httpd/apache

